#include <Adafruit_NeoPixel.h>

/*
  Analog input, analog output, serial output

  Reads an analog input pin, maps the result to a range from 0 to 255 and uses
  the result to set the pulse width modulation (PWM) of an output pin.
  Also prints the results to the Serial Monitor.

  The circuit:
  - potentiometer connected to analog pin 0.
    Center pin of the potentiometer goes to the analog pin.
    side pins of the potentiometer go to +5V and ground
  - LED connected from digital pin 9 to ground through 220 ohm resistor

  created 29 Dec. 2008
  modified 9 Apr 2012
  by Tom Igoe

  This example code is in the public domain.

  https://www.arduino.cc/en/Tutorial/BuiltInExamples/AnalogInOutSerial
*/

// These constants won't change. They're used to give names to the pins used:
const int analogInPin1 = A1;  // Analog input pin that the potentiometer is attached to
const int analogInPin2 = A2;  // Analog input pin that the potentiometer is attached to
const int analogInPin3 = A3;  // Analog input pin that the potentiometer is attached to
const int analogInPin4 = A4;  // Analog input pin that the potentiometer is attached to

//const int analogOutPin = A6;  // Analog output pin that the LED is attached to

int sensorValue1 = 0;  // value read from the pot
int sensorValue2 = 0;  // value read from the pot
int sensorValue3 = 0;  // value read from the pot
int sensorValue4 = 0;  // value read from the pot
//int outputValue = 0;  // value output to the PWM (analog out)
// Which pin on the Arduino is connected to the NeoPixels?
// On a Trinket or Gemma we suggest changing this to 1:
#define LED_PIN    3

// How many NeoPixels are attached to the Arduino?
#define LED_COUNT 40

// Declare our NeoPixel strip object:
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);
// Argument 1 = Number of pixels in NeoPixel strip
// Argument 2 = Arduino pin number (most are valid)
// Argument 3 = Pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
//   NEO_RGBW    Pixels are wired for RGBW bitstream (NeoPixel RGBW products)


void setup() {
  // initialize serial communications at 9600 bps:
  Serial.begin(9600);
  //pinMode(A1, INPUT);
  //pinMode(A6, OUTPUT);
    strip.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(50); // Set BRIGHTNESS to about 1/5 (max = 255)

}

void loop() {
  // read the analog in value:
  sensorValue1 = analogRead(analogInPin1);
  sensorValue2 = analogRead(analogInPin2);
  sensorValue3 = analogRead(analogInPin3);
  sensorValue4 = analogRead(analogInPin4);
  // map it to the range of the analog out:
  //outputValue = map(sensorValue, 0, 1023, 0, 255);
  // change the analog out value:
  //analogWrite(analogOutPin, outputValue);

  // print the results to the Serial Monitor:
  Serial.print("sensor1 = ");
  Serial.print(sensorValue1);
  Serial.print(" sensor2 = ");
  Serial.println(sensorValue2);
  Serial.print(" sensor3 = ");
  Serial.println(sensorValue3);
  Serial.print(" sensor4 = ");
  Serial.println(sensorValue4);
  //Serial.print("\t output = ");
  //Serial.println(outputValue);

  //if (sensorValue1 >10 && sensorValue2 >10){
  if (sensorValue1 >10){
    //animate the LEDs
  colorWipe(strip.Color(255,   0,   0), 10); // Red

  }else{

      //colorWipe(strip.Color(0,   0,   0), 10); // Red

  }

    if (sensorValue2 >10){
    //animate the LEDs
  colorWipe(strip.Color(255,   255,   255), 10); // white

  }

  if (sensorValue1 <100 && sensorValue2 <100){
      colorWipe(strip.Color(0,   0,   0), 10); // off


  }

  if (sensorValue3 >10){
    //animate the LEDs
  colorWipe(strip.Color(255,   90,   6), 10); // Orange

  }
  

  if (sensorValue1 <100 && sensorValue2 <100 && sensorValue3 <100){
      colorWipe(strip.Color(0,   0,   0), 10); // off

  }

  if (sensorValue4 >10){
    //animate the LEDs
  colorWipe(strip.Color(0,   0,   255), 10); // blue

  }

  if (sensorValue1 <100 && sensorValue2 <100 && sensorValue3 <100 && sensorValue4 <100){
      colorWipe(strip.Color(0,   0,   0), 10); // off

  }


  // wait 2 milliseconds before the next loop for the analog-to-digital
  // converter to settle after the last reading:
  delay(2);
}

// Fill strip pixels one after another with a color. Strip is NOT cleared
// first; anything there will be covered pixel by pixel. Pass in color
// (as a single 'packed' 32-bit value, which you can get by calling
// strip.Color(red, green, blue) as shown in the loop() function above),
// and a delay time (in milliseconds) between pixels.
void colorWipe(uint32_t color, int wait) {
  for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
    strip.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait);                           //  Pause for a moment
  }
}